#!/usr/local/bin/bash
#
# Dirk Dettmering
#
# 0.8 02.12.2016
#

# Servicerestarts:
HTTPRESTART="/usr/local/sbin/apachectl graceful"
FTPRESTART="service vsftpd restart"
IMAPRESTART="service dovecot restart"
SMTPRESTART="service postfix restart"

DATUM=`date +%d-%m-%Y`
STEMPEL=`date +%d-%m-%Y' '%H:%M`
DOMAINLIST="/usr/local/etc/letsencrypt/domains.txt"
TLOG="/tmp/acme-update.log"
LOG="/usr/local/etc/letsencrypt/logs/update.log"
STATUS=0

echo "#############################################################" >> $LOG
echo "" >> $LOG
echo $DATUM": Update der Zertifikate aller Domänen" >> $LOG

while read line; do
    IFS=" "
    set -- $line
    /usr/local/bin/bash /root/bin/cert-create.sh $1 $2 $3 $4 $5 $6; >> $LOG 2>&1
    RCODE=$?
    echo -e "$line\c" >> $LOG
    if [ $RCODE -ge 1 ]; then
	STATUS=$(($STATUS + $RCODE))
	echo "Status: "$STATUS
	#STATUS="Error"
	echo "Beim Erstellen des Zertifikats ist ein Fehler aufgetreten. Returncode: "$RCODE >> $LOG
    else
	echo ": OK" >> $LOG
    fi
done < /usr/local/etc/letsencrypt/domains.txt

echo "" >> $LOG

if [ $STATUS -eq 0 ]; then
    # Webserver neu Starten!
    $HTTPRESTARTCMD  > /dev/null 2>&1
    RCODE=$?
    if [ $RCODE -ge 1 ]; then
	STATUS="Error"
	echo "Beim Neustart des Apache ist ein Fehler aufgetreten: "$RCODE >> $LOG
    else
	echo "Apache erfolgreich neu gestartet" >> $LOG
    fi
    # FTP Server neu Starten!
    $FTPRESTARTCMD  > /dev/null 2>&1
    RCODE=$?
    if [ $RCODE -ge 1 ]; then
	STATUS="Error"
	echo "Beim Neustart des FTP Servers ist ein Fehler aufgetreten: "$RCODE >> $LOG
    else
	echo "VsFTPD erfolgreich neu gestartet" >> $LOG
    fi
    # Mailserver neu Starten!
    $IMAPRESTART > /dev/null 2>&1
    if [ $RCODE -ge 1 ]; then
	STATUS="Error"
	echo "Beim Neustart von Dovecot ist ein Fehler aufgetreten: "$RCODE >> $LOG
    else
	echo "Dovecot erfolgreich neu gestartet" >> $LOG
    fi
    $SMTPRESTART > /dev/null 2>&1
    if [ $RCODE -ge 1 ]; then
	STATUS="Error"
	echo "Beim Neustart von Postfix ist ein Fehler aufgetreten: "$RCODE >> $LOG
    else
	echo "Postfix erfolgreich neu gestartet" >> $LOG
    fi
else
    echo "Kein Neustart, weil ein Returncode groesser Null war!"
fi
echo "" >> $LOG

